program sliders;
const
	screenwidth=320;
	screenheight=240;
	boardwidth=240;
	boardheight=240;
	__A=_control;
	__B=_alt;
	__start=_enter;
	__select=_space;
	__R=_tab;
	__L=_backspace;
global
	image;
	move=-1;
	horizontal=4;
	vertical=4;
	positions[1000];
	string files[100];
	numfiles;
	struct highscore[323];
 		score;
	end
	record;
	clear=0;
	font;
	
	power[4]=1,256,256*256,256*256*256;
	textfile[1000];//we'll read up to 4000 chars
local
private
	i;
	string text="empty";
begin
	SET_MODE(320,240,16);
	load_fpg("sliders.fpg");
	map_put(0,0,1,280,120);
	font=load_fnt("bw.fnt");
	i=0;
	load("slider.sco",highscore);
	readfile("images/images.txt");
	resetpositions();
	Menu();
end;

process tile(width,height,number)
private
	i;
	j;
begin             
	graph=new_map(width,height,16);
	for(i=1;i<boardwidth/horizontal;i++)
		for(j=1;j<boardheight/vertical;j++)
			map_put_pixel(0,graph,i,j,MAP_GET_PIXEL(0,image,i+number%horizontal*width,j+number/horizontal*height));
		end
	end
	loop
		if(clear==1)
			UNLOAD_MAP(0,graph);
			return;
		end
		x=width*(0.5+positions[number]%horizontal);
		y=height*(0.5+positions[number]/horizontal);
		frame;
	end	
end;

process menu()
private
	string fileshow[1]="images","gp2x.png";
	filenum;
	i;
	change;
begin
	fileshow[1]=files[0];
	record=highscore[(horizontal-3)*18+vertical-3].score;
	image=load_png(join("/",&fileshow,2));
	redraw();
	WRITE_STRING(0,245,53,0,&fileshow[1]);
	write_int(0,248,98,0,&horizontal);
	write_int(0,303,98,0,&vertical);
	write_int(0,283,211,1,&record);
	loop
		record=highscore[(horizontal-3)*18+vertical-3].score;
		resetpositions();
		//CHOOSING FILES
		if(key(__R))
			fileshow[1]=files[++filenum];
			if(filenum>=numfiles)
				fileshow[1]=files[0];
				filenum=0;
			end
			UNLOAD_map(0,image);
			image=load_png(join("/",&fileshow,2));
      redraw();
			while(key(__R))frame;end
		end
		if(key(__L))
			fileshow[1]=files[--filenum];
			if(filenum<0)
				fileshow[1]=files[numfiles-1];
				filenum=numfiles-1;
			end
			unload_map(0,image);
			image=load_png(join("/",&fileshow,2));
			redraw();
			while(key(__L))frame;end
		end
		//Changing dimensions
		if(key(_right)and horizontal<20);
			horizontal++;
			redraw();
			while(key(_right))frame;end
		end
		if(key(_left)and horizontal>3);
			horizontal--;
			redraw();
			while(key(_left))frame;end
		end
		if(key(_up)and vertical<20);
			vertical++;
			redraw();
			while(key(_up))frame;end
		end
		if(key(_down)and vertical>3);
			vertical--;
			redraw();
			while(key(_down))frame;end
		end
		//playing a game
		if(key(__a))
			game();
		end	
		FRAME;
	end
end

process game();
private
	i;
	j;
	black;
	time;
	text[1];	
begin
	signal(father,s_freeze);
	scramble();
	text[0]=write_int(0,282,170,1,&time);
	timer[0]=0;
	loop
		time=timer[0]/100;
		black=horizontal*vertical-1;
		//moving tiles
		if(key(_left))
			if(positions[black]%horizontal != (-move+1)/2*(horizontal-1));
				positions[getblock(positions[black]-move)]+=move;
				positions[black]-=move;
			end
			while(key(_left))frame;end
		end
		if(key(_right))
			if(positions[black]%horizontal != (move+1)/2*(horizontal-1));
				positions[getblock(positions[black]+move)]-=move;
				positions[black]+=move;
			end
			while(key(_right))frame;end
		end
		if(key(_up))
			if(positions[black]/horizontal != (-move+1)/2*(vertical-1));
				positions[getblock(positions[black]-horizontal*move)]+=move*horizontal;
				positions[black]-=move*horizontal;
			end
			while(key(_up))frame;end
		end
		if(key(_down))
			if(positions[black]/horizontal != (move+1)/2*(vertical-1));
				positions[getblock(positions[black]+horizontal*move)]-=move*horizontal;
				positions[black]+=move*horizontal;
			end
			while(key(_down))frame;end
		end
		if(key(__a))
			move=-move;
		end
		j=0;
		for(i=0;i<horizontal*vertical;i++);
			if(i!=positions[i])
				j++;
			end
		end
		if(j==0)
			if(highscore[(horizontal-3)*18+vertical-3].score>time or highscore[(horizontal-3)*18+vertical-3].score==0)
				highscore[(horizontal-3)*18+vertical-3].score=time;
				text[1]=write(font,160,120,4,"Saving!");
				frame;
				save("slider.sco",highscore);
				delete_text(text[1]);
			end
			text[1]=write(font,160,120,4,"Press A to go back to menu");
			while(!key(__A));frame;end
			while(key(__A));frame;end
			delete_text(text[1]);
			delete_text(text[0]);	
			signal(father,s_wakeup);
			return;
		end
		if(key(__b))
			i=timer[0];
			while(key(__b))frame;end
			text[1]=write(font,160,120,4,"Press A to go back to menu or B to continue");
			while(!key(__a)and!key(__b))frame;end
			if(key(__a))
				while(key(__A));frame;end
				delete_text(text[1]);
				delete_text(text[0]);	
				signal(father,s_wakeup);
				return;
			end
			if(key(__b))
				while(key(__b));frame;end
				delete_text(text[1]);
				timer[0]=i;
			end
		end
		frame;
	end
end

process redraw()
private
	i;
begin
	clear=1;
	frame;frame;frame;
	clear=0;
	for(i=0;i<horizontal*vertical-1;i++)
		tile(boardwidth/horizontal,boardheight/vertical,i);
	end
end

process resetpositions()
private
	i;
begin
	for(i=0;i<1000;i++)
		positions[i]=i;
	end
end

function getblock(position)
private
	i;
begin
	for(i=0;i<horizontal*vertical;i++)
		if(positions[i]==position)
			return i;
		end
	end
	return -1;
end

process scramble()
private
	i;
	j;
	black;
	iterations;
begin
	iterations=(horizontal+vertical)*100;
	if(iterations>10000)
		iterations=10000;
	end
	for(i=0;i<iterations;i++);
		black=horizontal*vertical-1;
		j=rand(0,3);
		if(j==0)
			if(positions[black]%horizontal != (-move+1)/2*(horizontal-1));
				positions[getblock(positions[black]-move)]+=move;
				positions[black]-=move;
			end
			while(key(_left))frame;end
		end
		if(j==1)
			if(positions[black]%horizontal != (move+1)/2*(horizontal-1));
				positions[getblock(positions[black]+move)]-=move;
				positions[black]+=move;
			end
			while(key(_right))frame;end
		end
		if(j==2)
			if(positions[black]/horizontal != (-move+1)/2*(vertical-1));
				positions[getblock(positions[black]-horizontal*move)]+=move*horizontal;
				positions[black]-=move*horizontal;
			end
			while(key(_up))frame;end
		end
		if(j==3)
			if(positions[black]/horizontal != (move+1)/2*(vertical-1));
				positions[getblock(positions[black]+horizontal*move)]-=move*horizontal;
				positions[black]+=move*horizontal;
			end
			while(key(_down))frame;end
		end
	end
end

function max(a,b)
begin
	if(a>b)
		return a;
	end
	return b;
end

//just my readfile routine :),slightly modified
function readfile(string filename)
private
string chars[100];//up to 98 chars on a line (last two are for end of line)
lasttwo[2];
lastj;
j;
i;
begin
	load(filename,textfile);
		while(j<4000)
			lasttwo[0]= (textfile[j/4]/power[j%4])%256;
			chars[j-lastj]=chr(lasttwo[0]);
			j++;
			lasttwo[1]= (textfile[j/4]/power[j%4])%256;
			chars[j-lastj]=chr(lasttwo[1]);
			while((lasttwo[1]!=10 or lasttwo[0]!=13)and j<4000 and j-lastj<100);
				j++;                                                            
				lasttwo[0]=lasttwo[1];
				lasttwo[1]= (textfile[j/4]/power[j%4])%256;
				chars[j-lastj]=chr(lasttwo[1]);
			end;
			j++;
			if(j-lastj==101);
				numfiles=i;
				return;
			end
			files[i++]=join("",&chars,j-lastj-2);
			lastj=j;
		end
		numfiles=i;
	return;
end;